////////////////////////////////////////////////////////
//
// SourceMod Script
//
// DoD K98 Accuracy Enhencement
//
// Developed by FeuerSturm for the Realism Community!
//
////////////////////////////////////////////////////////
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name = "DoD K98 Accuracy Enhancement",
	author = "FeuerSturm",
	description = "Make the K98 completely accurate when standing still!",
	version = "1.0",
	url = "http://www.dodsourceplugins.net"
}

#define HIT_BODY		0

new Handle:AccuracyStatus = INVALID_HANDLE
new Float:g_LastK98Hit[MAXPLAYERS+1]
new K98Damage[8] = { 0, 110, 110, 110, 83, 83, 83, 83 }

public OnPluginStart()
{
	AccuracyStatus = CreateConVar("dod_k98accuracy_status", "0", "<1/0> = enable/disable K98 Accuracy Enhancement", FCVAR_PLUGIN, true, 0.0, true, 1.0)
	HookEvent("player_hurt", OnPlayerHurt, EventHookMode_Pre)
}

public Action:OnPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	decl String:Weapon[32]
	GetEventString(event, "weapon", Weapon, sizeof(Weapon))
	new hitgroup = GetEventInt(event, "hitgroup")
	if(StrEqual(Weapon, "k98", true) && hitgroup == HIT_BODY && GetConVarInt(AccuracyStatus) == 1)
	{
		return Plugin_Handled
	}
	return Plugin_Continue
}

public OnClientPutInServer(client)
{
	g_LastK98Hit[client] = GetGameTime()
	SDKHook(client, SDKHook_FireBulletsPost, OnFireBulletsPost)
	SDKHook(client, SDKHook_TraceAttack, OnTraceAttack)
}

public OnFireBulletsPost(client, shots, String:weaponname[])
{
	if(StrEqual(weaponname, "weapon_k98", true) && (GetGameTime() > g_LastK98Hit[client] + 1.0) && GetConVarInt(AccuracyStatus) == 1)
	{
		new buttons = GetClientButtons(client)
		if(buttons & IN_BACK || buttons & IN_FORWARD || buttons & IN_MOVELEFT || buttons & IN_MOVERIGHT)
		{
			return
		}
		new target = GetClientAimTarget(client, true)
		if(target > 0 && target <= MaxClients && IsClientInGame(target) && IsPlayerAlive(target) && GetClientTeam(target) > 1)
		{
			new hitgroup = GetHitGroup(client)
			if(hitgroup != 0)
			{
				new Float:attackerpos[3]
				GetClientAbsOrigin(client, attackerpos)
				if(SimulateHit(target, K98Damage[hitgroup], client, attackerpos))
				{
					FakePlayerHurt(target, client, hitgroup)
					return
				}
			}
		}
	}
	return
}

FakePlayerHurt(target, client, hitgroup)
{
	new health = GetClientHealth(target)
	new Handle:K98DMG = CreateEvent("player_hurt", true)
	SetEventInt(K98DMG, "userid", GetClientUserId(target))
	SetEventInt(K98DMG, "attacker", GetClientUserId(client))
	SetEventString(K98DMG, "weapon", "k98")
	SetEventInt(K98DMG, "health", health <= 0 ? 0 : health)
	SetEventInt(K98DMG, "damage", K98Damage[hitgroup])
	SetEventInt(K98DMG, "hitgroup", hitgroup)
	FireEvent(K98DMG, false)
}

public Action:OnTraceAttack(victim, &attacker, &inflictor, &Float:damage, &damagetype, &ammotype, hitbox, hitgroup)
{
	if(inflictor <= MaxClients && inflictor > 0 && attacker == inflictor && attacker != victim && IsClientInGame(attacker) && IsClientInGame(victim) && damagetype & DMG_BULLET && GetConVarInt(AccuracyStatus) == 1)
	{
		decl String:Weapon[32]
		GetClientWeapon(attacker, Weapon, sizeof(Weapon))
		if(StrEqual(Weapon, "weapon_k98", true) && hitgroup != HIT_BODY)
		{
			g_LastK98Hit[attacker] = GetGameTime()
		}
	}
	return Plugin_Continue
}

public GetHitGroup(client)
{
	new Float:vecClientEyePos[3]
	new Float:vecClientEyeAng[3]
	GetClientEyePosition(client, vecClientEyePos)
	GetClientEyeAngles(client, vecClientEyeAng)
	TR_TraceRayFilter(vecClientEyePos, vecClientEyeAng, MASK_SHOT, RayType_Infinite, TRDontHitSelf, client)
	if(TR_DidHit(INVALID_HANDLE))
	{
		new TRIndex = TR_GetEntityIndex(INVALID_HANDLE)
		if(TRIndex > 0 && TRIndex <= MaxClients && IsValidEntity(TRIndex) && IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) > 1)
		{
			new HitGroup = TR_GetHitGroup(INVALID_HANDLE)
			return HitGroup
		}
	}
	return 0
}

public bool:TRDontHitSelf(entity, mask, any:data)
{
	if(entity == data)
	{
		return false
	}
	return true
}

bool:SimulateHit(victim, damage, attacker, Float:attackerpos[3])
{
	if(victim > 0 && IsValidEdict(victim) && IsClientInGame(victim) && IsPlayerAlive(victim) && damage > 0)
	{
		decl String:dmg_str[16]
		IntToString(damage, dmg_str, sizeof(dmg_str))
		decl String:dmg_type_str[32]
		IntToString(DMG_BULLET, dmg_type_str, sizeof(dmg_type_str))
		new pointHurt = CreateEntityByName("point_hurt")
		if(pointHurt)
		{
			DispatchKeyValue(victim, "targetname", "hitme")
			DispatchKeyValue(pointHurt, "DamageTarget", "hitme")
			DispatchKeyValue(pointHurt, "Damage", dmg_str)
			DispatchKeyValue(pointHurt, "DamageType", dmg_type_str)
			DispatchKeyValue(pointHurt, "classname", "weapon_k98")
			DispatchSpawn(pointHurt)
			TeleportEntity(pointHurt, attackerpos, NULL_VECTOR, NULL_VECTOR)
			AcceptEntityInput(pointHurt, "Hurt", attacker)
			DispatchKeyValue(pointHurt, "classname", "point_hurt")
			DispatchKeyValue(victim, "targetname", "donthitme")
			RemoveEdict(pointHurt)
			return true
		}
	}
	return false
}